Bug 1108765 - Review Request: dSFMT - Double precision SIMD-oriented Fast Mersenne Twister
Summary: Review Request: dSFMT - Double precision SIMD-oriented Fast Mersenne Twister
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Milan Bouchet-Valat
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1040517
TreeView+ depends on / blocked
 
Reported: 2014-06-12 14:10 UTC by Xavier Lamien
Modified: 2014-10-09 19:57 UTC (History)
7 users (show)

Fixed In Version: dSFMT-2.2.3-4.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-09-23 04:44:44 UTC
nalimilan: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Xavier Lamien 2014-06-12 14:10:59 UTC
Spec URL: http://laxathom.fedorapeople.org/infra-fp/fpc/dSFMT/dSFMT.spec
SRPM URL: http://laxathom.fedorapeople.org/infra-fp/fpc/dSFMT/dSFMT-2.2.3-1.fc20.src.rpm
Description: 
The purpose of dSFMT is to speed up the generation by avoiding
the expensive conversion of integer to double (floating point).
dSFMT directly generates double precision floating point pseudorandom
numbers which have the IEEE Standard for Binary Floating-Point
Arithmetic (ANSI/IEEE Std 754-1985) format.

Fedora Account System Username: laxathom

Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=7039841

Comment 1 Tom "spot" Callaway 2014-06-13 19:48:47 UTC
Quick comments:

The license tag is wrong here, "Freely redistributable without restriction" only is valid for Firmware. 

http://www.math.sci.hiroshima-u.ac.jp/~%20m-mat/MT/SFMT/LICENSE.txt is BSD.

You do not need to delete the %{buildroot} at the beginning of %install.

Outside of that, the rpmlint is mostly safe to ignore:

dSFMT.src: W: spelling-error %description -l en_US pseudorandom -> pseudo random, pseudo-random, pseudonymous
dSFMT.x86_64: W: spelling-error %description -l en_US pseudorandom -> pseudo random, pseudo-random, pseudonymous
dSFMT.x86_64: W: shared-lib-calls-exit /usr/lib64/libdSFMT.so.2.2.3 exit@GLIBC_2.2.5

Show me a fixed spec and I'll finish a formal review.

Comment 2 Milan Bouchet-Valat 2014-06-15 20:41:04 UTC
Thanks for taking care of this!

I have spotted a few things:
>+LIBDIR     = $(PREFIX)/lib64
Maybe 'lib' would be better, since it does not depend on the architecture.

>+SSE2_LIBDIR = $(LIBDIR)/ss2
Looks like a typo, shouldn't it be '$(LIBDIR)/sse2'?

>+DESTDIR    = .
Shouldn't it be empty instead? The standard behavior is to install to $(PREFIX).

Also, I think the names of variables should be lower case as standard GNU variables:
http://www.gnu.org/software/make/manual/html_node/Directory-Variables.html

DESTDIR is apparently uppercase, though.


Finally, have you tried contacting the author? He might be interesting I applying your patch to make a real shared library upstream.

Comment 3 Xavier Lamien 2014-06-17 10:25:03 UTC
Good catch on value path. I'll make the change.

>> Finally, have you tried contacting the author? He might be interesting I applying your patch to make a real shared library upstream.

Not yet. However, I'd prefer to add a configure step upstream. I've something
downstream already. Will let you know.

Comment 5 Milan Bouchet-Valat 2014-06-17 14:44:40 UTC
Cool! Though you don't seem to have changed DESTDIR. Is this voluntary?


To use your package to build Julia, I'd need you to apply two patches Julia is using. The first one is fairly trivial, but the second may be more controversial as it also makes public a few private functions:
https://github.com/JuliaLang/julia/blob/master/deps/dSFMT.c.patch
https://github.com/JuliaLang/julia/blob/master/deps/dSFMT.h.patch

I've asked more information about the patches on the Julia development list:
https://groups.google.com/d/msg/julia-dev/oh_p5DeXzaQ/MU7d92O3Z7AJ

Comment 6 Milan Bouchet-Valat 2014-06-22 17:18:58 UTC
Apparently, the second patch is needed simply because dSFMT is originally supposed to be compiled with the calling code instead of as a separate library. So I think you should include it in your dSFMT-2.2.3_sharedlib.patch.

Comment 7 Milan Bouchet-Valat 2014-06-28 16:29:02 UTC
I've made a SRPM with the two patches merged into one (since they are highly related). It works for me with Julia:
http://nalimilan.perso.neuf.fr/transfert/dSFMT-2.2.3-3.fc20.src.rpm

Comment 8 Milan Bouchet-Valat 2014-07-02 20:31:26 UTC
I just noticed you kept this line in sharedlib.patch:
```
+SSE2FLAGS       = -msse2 -DHAVE_SSE2
```

If you keep it even on 32-bit, then dSFMT will effectively require Pentium 4 and above. I've no problem with that, but I'm not sure that's OK with regard to Fedora policies (I have the same problem for Julia...).

Comment 9 Milan Bouchet-Valat 2014-08-28 07:51:59 UTC
Would someone do the final review?

Spec URL: http://nalimilan.perso.neuf.fr/transfert/dSFMT-2.2.3-3.fc20.src.rpm
SRPM URL: http://nalimilan.perso.neuf.fr/transfert/dSFMT-2.2.3-3.fc20.src.rpm
Copr build: http://copr.fedoraproject.org/coprs/nalimilan/julia/build/21562/

I've been using this package for Julia builds in Copr for a few months without any issue.

Regarding my Comment 8 above, I was actually mistaken: dSFMT never works without SSE anyway.

Comment 10 Milan Bouchet-Valat 2014-09-03 17:29:10 UTC
OK, I have done the final review even if I have also modified the package myself. The new version adds %check and moves docs to a -devel-doc package. Everything looks good.

Xavier, are you still interested in this package? Can you handle the SCM request?


Spec URL: http://nalimilan.perso.neuf.fr/transfert/dSFMT.spec
SRPM URL: http://nalimilan.perso.neuf.fr/transfert/dSFMT-2.2.3-4.fc20.src.rpm
Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=7516831


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[ ]: Package does not contain kernel modules.
[ ]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[ ]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
     Note: Using prebuilt packages
[ ]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 28 files have unknown license. Detailed output of
     licensecheck in
     /home/milan/Dev/rpmbuild/review/koji/dSFMT/licensecheck.txt
[ ]: %build honors applicable compiler flags or justifies otherwise.
[ ]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
     Note: Using prebuilt rpms.
[ ]: Package contains no bundled libraries without FPC exception.
[ ]: Changelog in prescribed format.
[ ]: Sources contain only permissible code or content.
[ ]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package uses nothing in %doc for runtime.
[ ]: Package consistently uses macros (instead of hard-coded directory names).
[ ]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[ ]: Spec file is legible and written in American English.
[ ]: Package contains systemd file(s) if in need.
[ ]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 61440 bytes in 12 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Reviewer should test that the package builds in mock.
> Done via Koji (see above link).

[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[ ]: Scriptlets must be sane, if used.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: dSFMT-devel-doc-2.2.3-4.fc22.noarch.rpm
          dSFMT-2.2.3-4.fc22.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint dSFMT-devel-doc
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
dSFMT-devel-doc (rpmlib, GLIBC filtered):



Provides
--------
dSFMT-devel-doc:
    dSFMT-devel-doc



Source checksums
----------------
http://www.math.sci.hiroshima-u.ac.jp/~ m-mat/MT/SFMT/dSFMT-src-2.2.3.tar.gz :
  CHECKSUM(SHA256) this package     : 82344874522f363bf93c960044b0a6b87b651c9565b6312cf8719bb8e4c26a0e
  CHECKSUM(SHA256) upstream package : 82344874522f363bf93c960044b0a6b87b651c9565b6312cf8719bb8e4c26a0e


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review --rpm-spec --prebuilt --name dSFMT --define DISTTAG=rawhide
Buildroot used: fedora-20-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH

Comment 11 Milan Bouchet-Valat 2014-09-14 13:17:53 UTC
Package Change Request
======================
Package Name: dSFMT
Short Description: Double precision SIMD-oriented Fast Mersenne Twister
Upstream URL: http://www.math.sci.hiroshima-u.ac.jp/~%20m-mat/MT/SFMT/index.html
Branches: f20 f19 epel7
Owners: laxathom nalimilan
InitialCC:

Comment 12 Paulo Andrade 2014-09-14 17:41:57 UTC
Adding myself to CC to know when it is in the git repository.

Comment 13 Gwyn Ciesla 2014-09-15 12:13:19 UTC
WARNING: Package does not appear to exist in pkgdb currently.
NOTE: Misformatted request; using 'Branches' instead.
WARNING: SCM request was not the last comment.
WARNING: No new branches requested.

Comment 14 Milan Bouchet-Valat 2014-09-15 12:37:53 UTC
> WARNING: Package does not appear to exist in pkgdb currently.
I guess this happened because I forgot to assign the bug to myself when reviewing? Retrying.

Comment 15 Milan Bouchet-Valat 2014-09-15 12:46:19 UTC
> NOTE: Misformatted request; using 'Branches' instead.
Not sure what this means: I followed the syntax from https://fedoraproject.org/wiki/Package_SCM_admin_requests


Package Change Request
======================
Package Name: dSFMT
Short Description: Double precision SIMD-oriented Fast Mersenne Twister
Upstream URL: http://www.math.sci.hiroshima-u.ac.jp/~%20m-mat/MT/SFMT/index.html
New Branches: f19 f20 f21 epel7
Owners: laxathom nalimilan
InitialCC:

Comment 16 Milan Bouchet-Valat 2014-09-15 13:27:57 UTC
I just saw Paulo's mail on fedora-devel. Funny how I checked all fields, but not the header. So here we are:


New Package SCM Request
=======================
Package Name: dSFMT
Upstream URL: http://www.math.sci.hiroshima-u.ac.jp/~%20m-mat/MT/SFMT/index.html
Short Description: Double precision SIMD-oriented Fast Mersenne Twister
Owners: laxathom nalimilan
Branches: f19 f20 f21 epel7
InitialCC:

Comment 17 Gwyn Ciesla 2014-09-17 13:10:18 UTC
Git done (by process-git-requests).

Comment 18 Fedora Update System 2014-09-17 14:00:12 UTC
dSFMT-2.2.3-4.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/dSFMT-2.2.3-4.el7

Comment 19 Fedora Update System 2014-09-17 14:03:03 UTC
dSFMT-2.2.3-4.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/dSFMT-2.2.3-4.fc21

Comment 20 Fedora Update System 2014-09-17 14:03:52 UTC
dSFMT-2.2.3-4.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/dSFMT-2.2.3-4.fc20

Comment 21 Fedora Update System 2014-09-17 14:05:20 UTC
dSFMT-2.2.3-4.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/dSFMT-2.2.3-4.fc19

Comment 22 Fedora Update System 2014-09-18 16:12:51 UTC
dSFMT-2.2.3-4.fc21 has been pushed to the Fedora 21 testing repository.

Comment 23 Fedora Update System 2014-09-23 04:44:44 UTC
dSFMT-2.2.3-4.fc21 has been pushed to the Fedora 21 stable repository.

Comment 24 Fedora Update System 2014-09-27 09:57:52 UTC
dSFMT-2.2.3-4.fc20 has been pushed to the Fedora 20 stable repository.

Comment 25 Fedora Update System 2014-09-27 10:06:03 UTC
dSFMT-2.2.3-4.fc19 has been pushed to the Fedora 19 stable repository.

Comment 26 Fedora Update System 2014-10-09 19:57:39 UTC
dSFMT-2.2.3-4.el7 has been pushed to the Fedora EPEL 7 stable repository.


Note You need to log in before you can comment on or make changes to this bug.